### /give @p ravager_spawn_egg{display:{Name:'{"text":"Ravager"}'},EntityTag:{NoGravity:1b,Glowing:1b,DeathLootTable:"edd:attacker",PersistenceRequired:1b,NoAI:1b,Health:200f,Tags:["attacker"],Attributes:[{Name:generic.max_health,Base:200}]}} 64
### /summon ravager ~ ~ ~ {NoGravity:1b,Glowing:1b,DeathLootTable:"edd:attacker",PersistenceRequired:1b,NoAI:1b,Health:200f,Tags:["attacker"],CustomName:'{"text":"Ravager"}',Attributes:[{Name:generic.max_health,Base:200}]}

fill ~-1 ~ ~-1 ~1 ~2 ~1 air replace #airlikenw

#Blocked#
execute facing entity @e[type=armor_stand,tag=egg] eyes rotated ~ -0.0 unless block ^ ^1.3 ^1.3 #airwater run tag @s add blocked

    #Corner Problem#
execute facing entity @e[type=armor_stand,tag=egg] eyes rotated ~45 -0.0 unless block ^ ^1.3 ^1.2 #airlikelad run tag @s add corner
execute if entity @s[tag=corner] facing entity @e[type=armor_stand,tag=egg] eyes rotated ~-45 -0.0 unless block ^ ^1.3 ^1.2 #airlikelad run tag @s add blocked

    #Move#
execute as @s[x_rotation=-80..90,tag=!blocked] at @s unless entity @s[scores={slowed=1..}] facing entity @e[type=armor_stand,tag=egg] eyes rotated ~ -0.0 run teleport @s ^ ^ ^0.03 facing entity @e[type=armor_stand,tag=egg,limit=1,sort=nearest] eyes
execute as @s[x_rotation=-80..90,tag=!blocked] at @s if entity @s[scores={slowed=1..}] facing entity @e[type=armor_stand,tag=egg] eyes rotated ~ -0.0 run teleport @s ^ ^ ^0.02 facing entity @e[type=armor_stand,tag=egg,limit=1,sort=nearest] eyes
scoreboard players set @s[tag=!blocked] digger 0

    #Swim#
scoreboard players remove @s[scores={swim=1..}] swim 1
execute if block ~ ~1 ~ water run scoreboard players set @s swim 8
execute if entity @s[scores={swim=1..}] at @s positioned ~ ~0.05 ~ if block ~ ~1.75 ~ #airlike run teleport @s ~ ~ ~

#Left & Right#
execute at @s unless entity @s[tag=blocked] rotated ~ -0.0 unless block ^1.1 ^1.5 ^ #airlikelad positioned ^-0.07 ^ ^ run tp @s ^ ^ ^
execute at @s unless entity @s[tag=blocked] rotated ~ -0.0 unless block ^-1.1 ^1.5 ^ #airlikelad positioned ^0.07 ^ ^ run tp @s ^ ^ ^
execute at @s unless entity @s[tag=blocked] rotated ~ -0.0 unless block ^0.9 ^1.5 ^0.9 #airlikelad positioned ^-0.07 ^ ^ run tp @s ^ ^ ^
execute at @s unless entity @s[tag=blocked] rotated ~ -0.0 unless block ^-0.9 ^1.5 ^0.9 #airlikelad positioned ^0.07 ^ ^ run tp @s ^ ^ ^

#Up & Down#
    #Down#
execute unless entity @s[scores={swim=1..}] unless entity @s[x_rotation=-90..-80] rotated ~ -0.0 if block ~ ~-0.1 ~ #airlike if block ^0.8 ^-0.1 ^ #airlike if block ^-0.8 ^-0.1 ^ #airlike if block ^ ^-0.1 ^1 #airlike if block ^ ^-0.1 ^-1 #airlike unless block ~ ~-1.1 ~ #airlikenw run tp @s ~ ~-0.1 ~
execute unless entity @s[scores={swim=1..}] unless entity @s[x_rotation=-90..-80] rotated ~ -0.0 if block ~ ~-0.5 ~ #airlike if block ^0.8 ^-0.5 ^ #airlike if block ^-0.8 ^-0.5 ^ #airlike if block ^ ^-0.5 ^1 #airlike if block ^ ^-0.5 ^-1 #airlike unless block ~ ~-1.5 ~ #airlikenw unless block ~ ~ ~ water run tp @s ~ ~-0.5 ~
execute unless entity @s[scores={swim=1..}] unless entity @s[x_rotation=-90..-80] rotated ~ -0.0 if block ~ ~-0.1 ~ #airlike if block ^0.8 ^-0.1 ^ #airlike if block ^-0.8 ^-0.1 ^ #airlike if block ^ ^-0.1 ^1 #airlike if block ^ ^-0.1 ^-1 #airlike if block ~ ~-1.1 ~ #airlike if block ^ ^-1.1 ^-1 #airlike unless block ~ ~ ~ water run tp @s ~ ~-0.1 ~
execute unless entity @s[scores={swim=1..}] unless entity @s[x_rotation=-90..-80] rotated ~ -0.0 if block ~ ~-0.5 ~ #airlike if block ^0.8 ^-0.5 ^ #airlike if block ^-0.8 ^-0.5 ^ #airlike if block ^ ^-0.5 ^1 #airlike if block ^ ^-0.5 ^-1 #airlike if block ~ ~-1.5 ~ #airlike if block ^ ^-1.5 ^-1 #airlike unless block ~ ~ ~ water run tp @s ~ ~-0.5 ~
    #Up#
execute unless entity @s[x_rotation=-90..-80] rotated ~ -0.0 unless block ^ ^ ^0.8 #airlike positioned ~ ~1 ~ if block ^ ^ ^ #airlike if block ^ ^1 ^-0.5 #airlike if block ^ ^1 ^0.5 #airlike if block ^-0.5 ^1 ^ #airlike if block ^0.5 ^1 ^ #airlike run tag @s add openair
execute as @s[tag=openair] at @s positioned ~ ~1 ~ run fill ~-1 ~ ~-1 ~1 ~2 ~1 air
execute as @s[tag=openair] at @s positioned ~ ~1 ~ run tp @s ^ ^1 ^0.2
execute unless entity @s[x_rotation=-90..-80] unless entity @s[tag=openair] rotated ~ -0.0 unless block ^ ^ ^0.8 #airlike positioned ~ ~1 ~ if block ^ ^ ^ #airlike run fill ~-1 ~ ~-1 ~1 ~2 ~1 air
execute unless entity @s[x_rotation=-90..-80] unless entity @s[tag=openair] rotated ~ -0.0 unless block ^ ^ ^0.8 #airlike positioned ~ ~1 ~ if block ^ ^ ^ #airlike run tp @s ^ ^1 ^0.2
tag @s remove openair

#Dig#
scoreboard players add @s[tag=blocked] digger 1
execute if score players counter matches 3.. run scoreboard players add @s[tag=blocked] digger 1
execute as @s[tag=blocked,scores={digger=1}] at @s run fill ~ ~ ~ ~ ~1 ~ air
execute as @s[tag=blocked,scores={digger=40},x_rotation=-90..79] at @s rotated ~ -0.0 if block ^ ^2 ^1.5 air run fill ~-1 ~ ~-1 ~1 ~ ~1 dark_oak_planks
execute as @s[tag=blocked,scores={digger=60},x_rotation=0..90] at @s facing entity @e[type=armor_stand,tag=egg] eyes rotated ~ -0.0 run function edd:map2/mobs/ravdig
execute as @s[tag=blocked,scores={digger=60},x_rotation=-90..-0.1] at @s facing entity @e[type=armor_stand,tag=egg] eyes rotated ~ -0.0 run function edd:map2/mobs/ravdigup
execute as @s[tag=blocked,scores={digger=70..}] at @s run fill ~-1 ~ ~-1 ~1 ~1 ~1 air

    #Final Dig#
execute as @s[x_rotation=80..90] at @s facing entity @e[type=armor_stand,tag=egg] eyes run teleport @s ^ ^ ^0.03 facing entity @e[type=armor_stand,tag=egg,limit=1,sort=nearest] eyes
execute as @s[x_rotation=80..90] at @s facing entity @e[type=armor_stand,tag=egg] eyes rotated ~ -0.0 run fill ^-1 ^-0.5 ^-1 ^1 ^1 ^1 air

#Final Climb#
execute as @s[x_rotation=-90..-80] at @s facing entity @e[type=armor_stand,tag=egg] eyes run teleport @s ^ ^ ^0.03 facing entity @e[type=armor_stand,tag=egg,limit=1,sort=nearest] eyes
execute as @s[x_rotation=-90..-80] at @s facing entity @e[type=armor_stand,tag=egg] eyes run fill ^-0.3 ^ ^ ^0.3 ^1 ^3 air
execute as @s[x_rotation=-90..-80] at @s run fill ~ ~-0.5 ~ ~ ~-0.5 ~ dark_oak_planks replace #airlike


tag @s[tag=blocked] remove blocked
tag @s[tag=corner] remove corner

#Hurt#
execute store result score @s health run data get entity @s Health 1
tag @s[scores={health=200},tag=hurt] remove hurt
tag @s[scores={health=..199},tag=!hurt] add hurt

#Acid#
execute as @s at @s if block ~ ~-0.5 ~ crying_obsidian run function edd:dragons/black/acid

#Reach Egg#
execute as @s at @s if entity @e[type=armor_stand,tag=egg,limit=1,sort=nearest,distance=..1] run function edd:map2/mobs/damageegg